

//
// # Vars
//


var CHANNEL_BUTTON =
{
    ARM0 : 0,
    SOLO0 : 8,
    MUTE0 : 16,
    SELECT0 : 24,
    TOUCH0: 104
};

var MODIFIER =
{
    SHIFT : 70,
    OPTION : 71,
    CONTROL : 72,
    ALT : 73
};

var ENCODERS =
{
    PAN : 114,
    A1  : 80,
    A2  : 81,
    A3  : 82,
    A4  : 83,
    A5  : 34,
    A6  : 35,
    A7  : 36,
    A8  : 37,
    EQ1Freq  : 96,
    EQ2Freq  : 98,
    EQ3Freq  : 100,
    EQ4Freq  : 102,
    EQ1Gain  : 97,
    EQ2Gain  : 99,
    EQ3Gain  : 101,
    EQ4Gain  : 103,
    EQ1Width  : 104,
    EQ2Width  : 105,
    EQ3Width  : 106,
    EQ4Width  : 107,
};

var ENCODERCLICKS =
{
    PAN : 0x2D,
    A1  : 56,
    A2  : 57,
    A3  : 58,
    A4  : 59,
    A5  : 60,
    A6  : 61,
    A7  : 62,
    A8  : 63,
    VOLUME : 44,
    EQ1 : 64,
    EQ2 : 65,
    EQ3 : 66,
    EQ4 : 67,
};

var VPOT_ASSIGN =
{
    TRACK : 40,
    SEND : 41,
    PAN : 42,
    FX : 43,
    EQ : 44,
    INSTRUMENT : 45
};

var FADER_BANKS =
{
    BANK_UP : 46,
    BANK_DOWN : 47,
    CHANNEL_DOWN : 49,
    CHANNEL_UP : 48,
    FLIP : 50,
    GLOBAL_VIEW : 51
};

var AUTOMATION =
{
    READ_OFF : 74,
    WRITE : 75,
    TRIM : 76,
    TOUCH : 77,
    LATCH : 78,
    GROUP : 79
};

var NAVI =
{
    UP : 96,
    DOWN : 97,
    LEFT : 98,
    RIGHT : 99,
    ZOOM : 100
};

var MIDIMSGTYPES =
{
    NOTEON          : 0x90,
    NOTEOFF         : 0x80,
    CC              : 0xB0,
    CHANNELPRESSURE : 0xD0,
    PITCHBEND       : 0xE0
};

var TRANSPORT =
{
    REW : 91,
    FF : 92,
    STOP : 93,
    PLAY : 94,
    RECORD : 95,
    MARKER : 84,
    NUDGE :85,
    CYCLE : 86,
    DROP : 87,
    REPLACE : 88,
    CLICK : 89,
    SOLO : 90,
    WHEEL : 60,
    F1 : 0x36,
    F2 : 0x37,
    F3 : 0x38,
    F4 : 0x39,
    F5 : 0x3A,
    F6 : 0x3B,
    F7 : 0x3C,
    F8 : 0x3D,
};

var VPOT_PAGES_COUNT = 11;

var VPOT_PAGE =
{
    TRACK : 0,
    PAN : 1,
    FX : 2,
    EQ : 3,
    SEND0 : 4,
    SEND1 : 5,
    SEND2 : 6,
    SEND3 : 7,
    SEND4 : 8,
    JA : 9,
    VOLUME : 10
};

var DISPLAY_PAGES =
{
    NAME_AND_VOLUME : 0,
    NAME_AND_PAN : 1,
    FX : 2,
    EQ : 3,
    NAME_AND_SEND0 : 4,
    NAME_AND_SEND1 : 5,
    NAME_AND_SEND2 : 6,
    NAME_AND_SEND3 : 7,
    NAME_AND_SEND4 : 8
};

var APPLICATION =
{
    TOGGLE_NOTE_EDITOR : 62,
    TOGGLE_AUTOMATION_EDITOR : 63,
    TOGGLE_DEVICES : 64,
    TOGGLE_MIXER : 65,
    TOGGLE_BROWSER : 69,
    SAVE : 80,
    UNDO_REDO : 81,
    CANCEL : 82,
    ENTER : 83
};

var LED_MODES =
{
    NONE : 0,
    PAN : 1,
    NORMAL : 2
};


var VPOT0 = 16;
var VPOT_CLICK0 = 32;
var SET_PAGE0 = 54;
var SCRUB = 101;

var DISPLAY_WIDTH = 96;
var DISPLAY_WIDTH_THIRD = 48;
var SINGLE_DISPLAY_WIDTH = 12;
var SINGLE_DISPLAY_WIDTH_THIRD = 8;
var TOTAL_DISPLAY_SIZE = DISPLAY_WIDTH * 2;
var NUM_VU_MODES = 4;
var TOGGLE_VU_METER = 52;
var TOGGLE_TEMPO_OR_TICKS = 53;
var SYSEX_HDR = "f0 00 00 66 14";

var TOTAL_TRACKS = 8;





